Subject: bug#29107: closed (Re: bug#29107: 27.0.50; Infinite recursion in Ruby mode)

From: [email-masked] (GNU bug Tracking System)
Date: Sat, 02 Jan 2021 02:21:02 +0000

Your bug report

#29107: 27.0.50; Infinite recursion in Ruby mode

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
29107: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=29107
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#29107: 27.0.50; Infinite recursion in Ruby mode
From: Dmitry Gutov <[email-masked]>
To: Anders Lindgren <[email-masked]>, [email-masked]
Date: Sat, 2 Jan 2021 04:20:49 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

Version: 28.1

Hi Anders,

On 01.11.2017 21:52, Anders Lindgren wrote:
> I just noticed that Ruby mode can go into infinite recursion (or "Lisp 
> nesting exceeds ‘max-lisp-eval-depth’"). I managed to boil it down to 
> the following:
> 
>      Evaluate (setq debug-on-error t)
> 
>      Open a new file, say test.rb
>      Type:
> 
>          func do {
> 
>      And press return.
> 
> In the backtrace, the following is listed over and over again:
> 
>    ruby-smie--indent-to-stmt()
>    ruby-smie-rules(:before "{")
>    smie-indent--rule-1(:before "{" nil nil)
>    smie-indent--rule(:before "{")
>    smie-indent-keyword()
>    run-hook-with-args-until-success(smie-indent-keyword)
>    smie-indent-calculate()
>    smie-indent-virtual()
> 
> It happens in Emacs 25.2 and in a week-old build from the master branch.

Sorry about the long wait, it didn't seem like a critical issue given 
that the code in question was either a typo, or a very weird way to 
write a block. Please correct me if I'm wrong here.

Either way, it should be fixed now in master, commit 0f561ee553.

Subject: 27.0.50; Infinite recursion in Ruby mode
From: Anders Lindgren <[email-masked]>
To: [email-masked]
Date: Wed, 1 Nov 2017 20:52:31 +0100
List-Id: <debbugs-submit.debbugs.gnu.org>

Hi!

I just noticed that Ruby mode can go into infinite recursion (or "Lisp
nesting exceeds ‘max-lisp-eval-depth’"). I managed to boil it down to the
following:

    Evaluate (setq debug-on-error t)

    Open a new file, say test.rb
    Type:

        func do {

    And press return.

In the backtrace, the following is listed over and over again:

  ruby-smie--indent-to-stmt()
  ruby-smie-rules(:before "{")
  smie-indent--rule-1(:before "{" nil nil)
  smie-indent--rule(:before "{")
  smie-indent-keyword()
  run-hook-with-args-until-success(smie-indent-keyword)
  smie-indent-calculate()
  smie-indent-virtual()

It happens in Emacs 25.2 and in a week-old build from the master branch.

Sincerely,
    Anders Lindgren

In GNU Emacs 27.0.50 (build 2, x86_64-apple-darwin16.6.0, NS appkit-1504.83
Version 10.12.5 (Build 16F73))
 of 2017-10-25 built on mbp.lan
Repository revision: bc9300ac5ed3bdf52a2f8b9e217236e1ee76cd02
Windowing system distributor 'Apple', version 10.3.1504
Recent messages:
t
(New file)
Mark set
s-( is undefined
Mark set
Entering debugger...
Error in debug printer: (void-function t) [1113 times]
Error during redisplay: (ucs-normalize-hfs-nfd-pre-write-conversion 1 92)
signaled (error "Variable binding depth exceeds max-specpdl-size") [2 times]
set-auto-coding: Variable binding depth exceeds max-specpdl-size
Back to top level

Configured features:
JPEG NOTIFY ACL GNUTLS LIBXML2 ZLIB TOOLKIT_SCROLL_BARS NS

Important settings:
  value of $LC_CTYPE: UTF-8
  value of $LANG: en_SE.UTF-8
  locale-coding-system: utf-8-unix

Major mode: Special

Minor modes in effect:
  tooltip-mode: t
  global-eldoc-mode: t
  electric-indent-mode: t
  mouse-wheel-mode: t
  tool-bar-mode: t
  menu-bar-mode: t
  file-name-shadow-mode: t
  global-font-lock-mode: t
  font-lock-mode: t
  blink-cursor-mode: t
  auto-composition-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t
  buffer-read-only: t
  line-number-mode: t
  transient-mark-mode: t

Load-path shadows:
None found.

Features:
(shadow sort mail-extr emacsbug message rmc puny seq byte-opt dired
dired-loaddefs format-spec rfc822 mml mml-sec password-cache epa derived
epg epg-config gnus-util rmail rmail-loaddefs mm-decode mm-bodies
mm-encode mail-parse rfc2231 mailabbrev gmm-utils mailheader sendmail
rfc2047 rfc2045 ietf-drums mm-util mail-prsvr mail-utils help-mode
warnings gv bytecomp byte-compile cl-loaddefs cl-lib cconv debug
vc-dispatcher vc-svn ruby-mode smie easymenu elec-pair time-date tooltip
eldoc electric uniquify ediff-hook vc-hooks lisp-float-type mwheel
term/ns-win ns-win ucs-normalize mule-util term/common-win tool-bar dnd
fontset image regexp-opt fringe tabulated-list replace newcomment
text-mode elisp-mode lisp-mode prog-mode register page menu-bar
rfn-eshadow isearch timer select scroll-bar mouse jit-lock font-lock
syntax facemenu font-core term/tty-colors frame cl-generic cham georgian
utf-8-lang misc-lang vietnamese tibetan thai tai-viet lao korean
japanese eucjp-ms cp51932 hebrew greek romanian slovak czech european
ethiopic indian cyrillic chinese composite charscript charprop
case-table epa-hook jka-cmpr-hook help simple abbrev obarray minibuffer
cl-preloaded nadvice loaddefs button faces cus-face macroexp files
text-properties overlay sha1 md5 base64 format env code-pages mule
custom widget hashtable-print-readable backquote kqueue cocoa ns
multi-tty make-network-process emacs)

Memory information:
((conses 16 209217 10912)
 (symbols 48 20615 1)
 (miscs 40 57 249)
 (strings 32 30746 1897)
 (string-bytes 1 808845)
 (vectors 16 35813)
 (vector-slots 8 721700 15012)
 (floats 8 49 266)
 (intervals 56 218 0)
 (buffers 992 14))